use serde::{Deserialize, Serialize};
use tracing::{info, instrument};

use crate::db::concour::Concour;

#[derive(Serialize, Deserialize, Debug, Clone)]
pub enum EndConcourError {
    DoesntExist,
    FindError(String),
    UnknownError(String),
}

#[instrument(level = "info")]
pub async fn end_concour(
    server_id: u64,
    channel_id: u64,
) -> Result<Option<Concour>, EndConcourError> {
    let concour = match Concour::find_by_server_id_channel_id(&server_id, &channel_id).await {
        Ok(list_concour) => list_concour,
        Err(err) => {
            tracing::error!(error = err.to_string(), "Error finding concour");
            return Err(EndConcourError::UnknownError(
                "Error finding concour".to_string(),
            ));
        }
    };

    if concour.is_none() {
        info!("Concour doesn't exist");
        return Err(EndConcourError::DoesntExist);
    }
    todo!("Setup logic to end the waiting period for the concour");
    // let mut concour = concour.unwrap();

    // // Update status to Finished

    // match concour.update().await {
    //     Ok(_) => {}
    //     Err(err) => {
    //         tracing::error!(error = err.to_string(), "Error updating concour");
    //         return Err(EndConcourError::UnknownError(
    //             "Error updating concour".to_string(),
    //         ));
    //     }
    // }
    // Ok(Some(concour))
}
